"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lastTaskId = 0;
var callbacks = new Map();
exports.loadWorker = function (url, options) {
    var worker = new Worker(url, options);
    worker.onmessage = function (event) {
        var _a = event.data, errored = _a[0], taskId = _a[1], data = _a[2];
        var _b = callbacks.get(taskId), resolve = _b[0], reject = _b[1];
        if (!errored)
            resolve(data);
        else
            reject(data);
        callbacks.delete(taskId);
    };
    var dispatch = function (data, transferList) {
        var taskId = lastTaskId++;
        var promise = new Promise(function (resolve, reject) {
            callbacks.set(taskId, [resolve, reject]);
        });
        worker.postMessage([taskId, data], transferList);
        return promise;
    };
    return dispatch;
};
